#ifndef COMMON_H
#define COMMON_H

#include <iostream>
#include <iomanip>
#include <fstream>
//#include <typeinfo>
//#include <string>
#include <vector> 
#include <map> 
#include <regex>
#include <unistd.h>
#include <cstdint>
using namespace std;

#define version "3.19"

extern bool little_endian;                             // тип процессора: big/litle endian 
extern int debug_level;                                // уровень отладочного вывода

typedef uint64_t addr_t; 
#define ADRLEN 2                                       // число байт в отображении адреса
static const int w2b = sizeof( int64_t );              // число байт в слове данных

ostream& operator <<( ostream& out, const vector<string>& t );

inline regex pattern( const string& r ) {
   //   try { return regex( r ); }                     // с учётом регистра
   try { return regex( r, regex_constants::icase ); }  // без учёта регистра
   catch( regex_error& e ) {                           // ошибка записи регулярного выражения
      cerr << "синтаксис регулярного выражения:\t" << r << endl;
      exit( 3 );
   }
}
// static constexpr flag_type basic = regex_constants::basic;
// static constexpr flag_type extended = regex_constants::extended;
// static constexpr flag_type awk = regex_constants::awk;
// static constexpr flag_type grep = regex_constants::grep;

#endif
